﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Task3
{
    class RotatingWalk
    {
        static void ChangeDirection(ref int dx, ref int dy)
        {
            int[] dirX = { 1, 1, 1, 0, -1, -1, -1, 0 };
            int[] dirY = { 1, 0, -1, -1, -1, 0, 1, 1 };
            int curDirection = 0;
            for (int i = 0; i < 8; i++)
            {
                if (dirX[i] == dx && dirY[i] == dy)
                {
                    curDirection = i; break;
                }
            }
            if (curDirection == 7)
            {
                dx = dirX[0];
                dy = dirY[0];
                return;
            }
            dx = dirX[curDirection+1];
            dy = dirY[curDirection + 1];
        }

        static bool CheckDirections(int[,] arr, int x, int y)
        {
            int[] dirX = { 1, 1, 1, 0, -1, -1, -1, 0 };
            int[] dirY = { 1, 0, -1, -1, -1, 0, 1, 1 };
            for (int i = 0; i < 8; i++)
            {
                if (x + dirX[i] >= arr.GetLength(0) || x + dirX[i] < 0)
                    dirX[i] = 0;
                if (y + dirY[i] >= arr.GetLength(0) || y + dirY[i] < 0)
                    dirY[i] = 0;
            }
            for (int i = 0; i < 8; i++)
            {
                if (arr[x + dirX[i], y + dirY[i]] == 0)
                    return true;
            }
            return false;
        }

        static void GetFirstEmptyCell (int[,] arr, out int x, out int y)
        {
            x = 0;
            y = 0;
            for (int i = 0; i < arr.GetLength(0); i++)
            {
                for (int j = 0; j < arr.GetLength(0); j++)
                {
                    if (arr[i, j] == 0)
                    {
                        x = i;
                        y = j;
                        return;
                    }
                }
            }
        }

        static void Main(string[] args)
        {
            //Console.WriteLine("Enter a positive number ");
            //string input = Console.ReadLine();
            //int n = 0;
            //while (!int.TryParse(input, out n) || n < 0 || n > 100)
            //{
            //    Console.WriteLine("You haven't entered a correct positive number");
            //    input = Console.ReadLine();
            //}
            int n = 3;
            int[,] output = new int[n, n];
            int stepsInDirection = n;
            int number = 1;
            int i = 0;
            int j = 0;
            int dx = 1; int dy = 1;
            while(true) //malko e kofti tova uslovie, no break-a raboti 100% :)
            {
                output[i, j] = number;
                if (!CheckDirections(output, i, j))
                {
                    break;      // prekusvame ako sme se zadunili
                }
                if (i+dx >= n || i+dx < 0 || j+dy >= n || j+dy < 0 || output[i+dx, j+dy] != 0)
                {
                    while ((i + dx >= n || i + dx < 0 || j + dy >= n || j + dy < 0 || output[i + dx, j + dy] != 0))
                    {
                        ChangeDirection(ref dx, ref dy);
                    }
                }
                i += dx;
                j += dy;
                number++;
            }
            for (int p = 0; p < n; p++)
            {
                for (int q = 0; q < n; q++)
                {
                    Console.Write("{0,3}", output[p, q]);
                }
                Console.WriteLine();                
            }
            GetFirstEmptyCell(output, out i, out j);
            if (i != 0 && j != 0) // taka go napravih, zashtoto funkciqta ne mi davashe da ne si definiram out parametrite
            {
                dx = 1;
                dy = 1;
                while (true) //malko e kofti tova uslovie, no break-a raboti 100% :)
                {
                    output[i, j] = number;
                    if (!CheckDirections(output, i, j))
                    {
                        break;      // prekusvame ako sme se zadunili
                    }
                    if (i + dx >= n || i + dx < 0 || j + dy >= n || j + dy < 0 || output[i + dx, j + dy] != 0)
                    {
                        while ((i + dx >= n || i + dx < 0 || j + dy >= n || j + dy < 0 || output[i + dx, j + dy] != 0))
                        {
                            ChangeDirection(ref dx, ref dy);
                        }
                    }
                    i += dx;
                    j += dy;
                    number++;
                }
            }
            
            for (int p = 0; p < n; p++)
            {
                for (int q = 0; q < n; q++)
                {
                    Console.Write("{0,3}", output[p, q]);
                }
                Console.WriteLine();
            }
        }
    }
}
